﻿@model Tuple<List<PurchaseRequestLineView>, PurchaseRequestCombo, UsersSettingView, DateTime?>

@{
    string test = "";
}
<script type="text/javascript">

    $("#RightLateralMessageContent").html("@PurchaseOrders.IWACTTO");

    var DistrRuleItems = [];
    var WhItems = [];
    var GLItems = [];
    $.ajax({
        url: '/Purchase/PurchaseRequest/_GetDistributionRuleList',
        type: 'POST',
        data: {},
        traditional: true,
        cache: false,
        dataType: 'json',
        success: function (data) {
            $.each(data, function (key) {

                DistrRuleItems.push({
                    value: data[key].Value,
                    label: data[key].Text
                });

            });
        }, error: function (xhr) {
            ErrorCalls(xhr.status)

        },
    });

    $.ajax({
        url: '/Purchase/PurchaseRequest/_GetWarehouseList',
        type: 'POST',
        data: {},
        traditional: true,
        cache: false,
        dataType: 'json',
        success: function (data) {
            $.each(data, function (key) {
                WhItems.push({
                    value: data[key].Value,
                    label: data[key].Text
                });
            });
        }, error: function (xhr) {
            ErrorCalls(xhr.status)


        },
    });

    $.ajax({
        url: '/Purchase/PurchaseRequest/_GetGLAccountList',
        type: 'POST',
        data: { pPageKey: "@ViewBag.PageKey" },
        traditional: true,
        cache: false,
        dataType: 'json',
        success: function (data) {
            $.each(data, function (key) {
                GLItems.push({
                    value: data[key].Value,
                    label: data[key].Text
                });
            });
        }, error: function (xhr) {

            ErrorCalls(xhr.status)

        },
    });
</script>
<div id="TableItemsForm">
    <table class="table table-striped PurchaseRequestTable">
        <thead>
            <tr>
                <th>&nbsp;</th>
                <th><strong>@PurchaseOrders.Item</strong></th>
                <th><strong>@PurchaseOrders.Description</strong></th>
                <th><strong>Wh</strong></th>
                <th>@PurchaseOrders.DR</th>
                <th>@PurchaseOrders.GLA</th>
                <th>@PurchaseOrders.FT</th>
                <th><strong>@PurchaseOrders.ReqDate</strong></th>
                <th><strong>@PurchaseOrders.Qty</strong></th>
                <th><strong>@PurchaseOrders.Currency</strong></th>
                <th><strong>Info @PurchaseOrders.Price</strong></th>
                <th><strong>Uom</strong></th>
                @{
                    if (Model.Item1.Count > 0)
                    {
                        if (Model.Item1.FirstOrDefault().MappedUdf != null && Model.Item1.FirstOrDefault().MappedUdf.Count > 0)
                        {
                            foreach (var DictRow in Model.Item1.FirstOrDefault().MappedUdf.OrderBy(c => c.UDFName))
                            {
                                <th><strong>@DictRow.UDFDesc</strong></th>
                            }
                        }
                    }
                }
                <th><strong>Total</strong></th>
            </tr>
        </thead>
        <tbody>
            @if (Model != null)
            {
                foreach (PurchaseRequestLineView item in Model.Item1)
                {
                    string mTAuto = "AutoComplete" + item.LineNum;
                    string mTAutoDR = "AutoCompleteDR" + item.LineNum;
                    string mDescItem = "DescItem" + item.LineNum;
                    string mTAutoGLAccount = "AutoCompleteGL" + item.LineNum;
                    string mFreeTxt = "FreeTxt" + item.LineNum;
                    string mTxtId = "txt" + item.LineNum;
                    string mReqDateId = "ReqDate" + item.LineNum;
                    string mTdId = "td" + item.LineNum;
                    string mDpId = "dp" + item.LineNum;
                    string mTxtCountId = "txtcount" + item.LineNum;
                    string mTrId = "tr" + item.LineNum;
                    string mUOMAuto = "UOMAuto" + item.LineNum;
                    string currencySelected = (!string.IsNullOrEmpty(item.Currency) ? item.Currency : Model.Item2.RatesList.Where(c => c.System == true).FirstOrDefault().Currency).ToString().Trim();
                    <tr id='@mTrId'>
                        <td>
                            @if (item.LineStatus == "O")
                            {
                                <button onclick="DeleteRow('@item.LineNum')" type="button" class="btn btn-primary btn-xs"><span class="glyphicon glyphicon-trash"></span></button>
                            }
                            <input type="hidden" id="@item.LineNum" value="@item.Dscription" />
                        </td>
                        <td class="item_desc_table">@item.ItemCode</td>
                        <td><input id='@mDescItem' class="form-control descDocuments" onchange="LineWasChanged('@item.LineNum');" value='@item.Dscription' /></td>
                        <td><input id='@mTAuto' class="form-control autoComplete" value="@(Model.Item3.DftWhs == null ? item.WhsCode : Model.Item3.DftWhs)" onchange="LineWasChanged('@item.LineNum');" title="type &quot;a&quot;"></td>
                        <td><input id='@mTAutoDR' class="form-control autoComplete" value="@(item.OcrCode != null ? item.OcrCode : Model.Item3.DftDistRule)" onchange="LineWasChanged('@item.LineNum');" title="type &quot;a&quot;"></td>
                        <td><input id='@mTAutoGLAccount' class="form-control autoCompleteGLAccount" value="@(item.GLAccount != null ? item.GLAccount.FormatCode : "")" onchange="LineWasChanged('@item.LineNum');" title="type &quot;a&quot;"></td>
                        <td><input id='@mFreeTxt' class="form-control autoCompleteGLAccount" placeholder="@PurchaseOrders.FT" onchange="LineWasChanged('@item.LineNum');" value="@(item.FreeTxt)"></td>
                        <td>
                            <div class="input-group date dateDocuments">
                                <input value="@((item.PQTReqDate != null && item.PQTReqDate != DateTime.MinValue) ? item.PQTReqDate.ToString().AsDateTime().ToShortDateString() : ((Model.Item4 != null && Model.Item4 != DateTime.MinValue) ? Model.Item4.ToString().AsDateTime().ToShortDateString() : ""))" class="form-control valid" data-val="true" data-val-date=" must be a date." id="@mReqDateId" name="@mReqDateId" onchange="LineWasChanged('@item.LineNum');" placeholder="@PurchaseRequest.RD" type="text"><span class="input-group-addon"><i class="glyphicon glyphicon-calendar"></i></span>
                            </div>
                        </td>
                        <td><input type="number" id='@mTxtCountId' class="form-control" value='@(((UserView)Session["UserLogin"]).CompanyConnect.FormatNumberWithDecimals(Enums.Decimals.Quantity, (item.Quantity != null ? item.Quantity.Value : 0)))' min="0" onchange="LineWasChanged('@item.LineNum'); ChangeValue('@item.LineNum'); ChangeQuantityValue('@item.LineNum', '@Shared.NumberGreaterZero');" style="width:100px;" /></td>
                        <td>
                            @Html.DropDownListFor(c => test, new SelectList(Model.Item2.CurrencyList, "CurrCode", "CurrName", currencySelected), new { @Id = mDpId, @class = "form-control currencyDocuments", @onchange = "LineWasChanged('" + @item.LineNum + "'); ChangeValue('" + @item.LineNum + "')" })
                        </td>
                        <td><input onchange="LineWasChanged('@item.LineNum'); ChangeValue('@item.LineNum');" type="number" class="form-control" id='@mTxtId' value='@(((UserView)Session["UserLogin"]).CompanyConnect.FormatNumberWithDecimals(Enums.Decimals.Price, (item.PriceBefDi != null ? item.PriceBefDi.Value : 0))) @String.Format(CultureInfo.InvariantCulture, "{0:0.00}", item.PriceBefDi)' style="width:140px;" /></td>
                        <td><input id='@mUOMAuto' class="form-control autoComplete" value="@(item.UomCode != null ? item.UomCode : string.Empty)" onchange="LineWasChanged('@item.LineNum');" title="type &quot;a&quot;"></td>

                        @{
                    if (Model.Item1.Count > 0)
                    {
                        if (Model.Item1.FirstOrDefault().MappedUdf != null && Model.Item1.FirstOrDefault().MappedUdf.Count > 0)
                        {
                            foreach (var DictRow in item.MappedUdf.OrderBy(c => c.UDFName))
                            {
                                <td>
                                    @if (DictRow.ListUFD1.Count > 0)
                                    {
                                        @Html.DropDownList(DictRow.UDFName, new SelectList(
                                                         DictRow.ListUFD1,
                                                        "FldValue",
                                                         "Descr", DictRow.Value), new { @Id = "LINEUDF_" + DictRow.UDFName + item.LineNum, @Name = "LINEUDF_" + DictRow.UDFName, @class = "form-control UDFField", @onchange = "LineWasChanged('" + item.LineNum + "');" })
                                    }
                                    else
                                    {
                                        <input id='LINEUDF_@DictRow.UDFName@item.LineNum' name="LINEUDF_@DictRow.UDFName" class="form-control UDFField" value='@DictRow.Value' onchange="LineWasChanged('@item.LineNum');" />
                                    }
                                </td>
                            }
                        }
                    }
                        }
                        <td id='@mTdId'>@(((UserView)Session["UserLogin"]).CompanyConnect.FormatNumberWithDecimals(Enums.Decimals.Price, (decimal)((item.Price != null && item.Quantity != null) ? (item.Price * item.Quantity) : 0)))</td>
                    </tr>
                    <script type="text/javascript">
                        $("#" + '@mTAuto').autocomplete({
                            source: WhItems
                        });
                        $("#" + '@mTAutoDR').autocomplete({
                            source: DistrRuleItems
                        });
                        $("#" + '@mTAutoGLAccount').autocomplete({
                            source: GLItems
                        });

                        //Unit Of Measure Autocomplete
                        $("#" + '@mUOMAuto').autocomplete({
                            source: function (request, response) {
                                $.ajax({
                                    url: '/Purchase/PurchaseRequest/GetUnitOfMeasure',
                                    type: 'POST',
                                    data: { ItemCode: '@item.ItemCode' },
                                    async: true,
                                    dataType: 'json',
                                    success: function (data) {
                                        var UOMitems = [];

                                        $.each(data, function (key) {

                                            UOMitems.push({
                                                value: data[key].UomCode,
                                                label: data[key].UomName
                                            });

                                        });

                                        response(UOMitems);

                                    }, error: function (xhr) {
                                        ErrorCalls(xhr.status)

                                    },
                                });

                            },
                            minLength: 2
                        });
                    </script>
                }
            }
        </tbody>
    </table>
</div>
